function junkk = inner_RWMH(b, ix2, ilogpo2, ModelName, MhDirectoryName, fblck, fline, npar, nblck, ...
nruns, NewFile, MAX_nruns, d, ProposalFun, TargetFun, mh_bounds, jscale, ...
n, amh_t0, amh_eps, d_saved, Gbayestopt_, Gestim_params_, Goptions_, ...
Gtrend_coeff_, GM_, Goo_, Gxparam1_test, Git_, varargin)


junkk = 1;


my_vararg = varargin{:};


InitSizeArray = min([repmat(MAX_nruns,nblck,1) fline+nruns-1],[],2);

if(~exist('mjdgges'))
    addpath('C:/dynare/4.0.2/mex/2007b/');
end

global bayestopt_ estim_params_ options_ trend_coeff_ M_ oo_ ...
		xparam1_test it_;
	
if(isempty(bayestopt_))
    bayestopt_ = Gbayestopt_;
end
if(isempty(estim_params_))
    estim_params_ = Gestim_params_;
end
if(isempty(options_))
    options_ = Goptions_;
end
if(isempty(trend_coeff_))
    trend_coeff_ = Gtrend_coeff_;
end
if(isempty(M_))
    M_ = GM_;
end
if(isempty(oo_))
    oo_ = Goo_;
end
if(isempty(it_))
    it_ = Git_;
end
if(isempty(xparam1_test))
    xparam1_test = Gxparam1_test;
end

if(strcmp(TargetFun, 'DsgeVarLikelihood'))
    mYY = my_vararg{1};
    mYX = my_vararg{2};
    mXY = my_vararg{3};
    mXX = my_vararg{4};
    
    % DSGE-BVAR stuff
    assignin('base', 'mYY', mYY);
    assignin('base', 'mYX', mYX);
    assignin('base', 'mXY', mXY);
    assignin('base', 'mXX', mXX);
%     gend = my_vararg{5};
% 	data = my_vararg{6};
else
% 	gend = my_vararg{1};
% 	data = my_vararg{2};
end


x2 = zeros(InitSizeArray(b),npar);
logpo2 = zeros(InitSizeArray(b),1);

slowness = 0;

if exist('OCTAVE_VERSION')
  diary off;
else
  hh = waitbar(0,['Please wait... Metropolis-Hastings (' int2str(b) '/' int2str(nblck) ')...']);
  set(hh,'Name','Metropolis-Hastings');
  hhpos = get(hh, 'Position');				% Jitter the waitbar window, so all cores are visible
  hhpos(1) = hhpos(1)*(1 + randn/5);
  hhpos(2) = hhpos(2)*(1 + randn/5);
  set(hh, 'Position', hhpos);
end
isux = 0;
jsux = 0;
irun = fline(b);
j = 1;
d = d_saved;



pfun = [ TargetFun, '_parallel' ];


prefetch_method = 1;			% Always Prepare For Rejection is the default

prop = zeros(4, npar);



while j <= nruns(b)
	

	
	if(prefetch_method==1)
		for i = 1:4
			prop(i,:) = feval(ProposalFun, ix2(b,:), d * jscale, n);
		end
	elseif(prefetch_method==2)
		prop(1,:) = feval(ProposalFun, ix2(b,:), d * jscale, n);
		prop(2,:) = feval(ProposalFun, prop(1,:), d * jscale, n);
		prop(3,:) = feval(ProposalFun, ix2(b,:), d * jscale, n);
		prop(4,:) = feval(ProposalFun, prop(3,:), d * jscale, n);
	end
	
	result_series = zeros(4,1);
	parfor i = 1:4
		par = prop(i,:);
		if all( par(:) > mh_bounds(:,1) ) && all( par(:) < mh_bounds(:,2) )
			result_series(i) = - feval(pfun, par(:), ...
						Gbayestopt_,  Gestim_params_,  Goptions_,  Gtrend_coeff_,  GM_,  Goo_,  Gxparam1_test,  Git_, ...
						varargin{:});
		else
			result_series(i) = -inf;
		end
	end
	
	if(prefetch_method==1)
		i = 1;
		still_ok = true;
		while(still_ok && (i < 5) && (irun <= InitSizeArray(b)) && (j <= nruns(b)))
			logpost = result_series(i);
			par = prop(i,:);
			if (logpost > -inf) && (log(rand) < logpost-ilogpo2(b))
				x2(irun,:) = par;
				ix2(b,:) = par;
				logpo2(irun) = logpost; 
				ilogpo2(b) = logpost;
				isux = isux + 1;
				jsux = jsux + 1;
				still_ok = false;
			else    
				x2(irun,:) = ix2(b,:);
				logpo2(irun) = ilogpo2(b);
			end
			i = i + 1;
			j = j + 1;
			irun = irun + 1;
		end
	elseif(prefetch_method==2)
		logpost = result_series(1);
		par = prop(1,:);
		if (logpost > -inf) && (log(rand) < logpost-ilogpo2(b))
			x2(irun,:) = par;
			ix2(b,:) = par;
			logpo2(irun) = logpost; 
			ilogpo2(b) = logpost;
			isux = isux + 1;
			jsux = jsux + 1;
			next_one = 2;
			next_acc = 0;
			next_rej = 0;
		else    
			x2(irun,:) = ix2(b,:);
			logpo2(irun) = ilogpo2(b);
			next_one = 3;
			next_acc = 4;
			next_rej = 0;
		end
		j = j + 1;
		irun = irun + 1;
		if(((irun <= InitSizeArray(b)) && (j <= nruns(b))) )
			logpost = result_series(next_one);
			par = prop(next_one,:);
			if (logpost > -inf) && (log(rand) < logpost-ilogpo2(b))
				x2(irun,:) = par;
				ix2(b,:) = par;
				logpo2(irun) = logpost; 
				ilogpo2(b) = logpost;
				isux = isux + 1;
				jsux = jsux + 1;
				next_one = next_acc;
			else    
				x2(irun,:) = ix2(b,:);
				logpo2(irun) = ilogpo2(b);
				next_one = next_rej;
			end
			j = j + 1;
			irun = irun + 1;
			if((next_one > 0) && ((irun <= InitSizeArray(b)) && (j <= nruns(b))) )
				logpost = result_series(next_one);
				par = prop(next_one,:);
				if (logpost > -inf) && (log(rand) < logpost-ilogpo2(b))
					x2(irun,:) = par;
					ix2(b,:) = par;
					logpo2(irun) = logpost; 
					ilogpo2(b) = logpost;
					isux = isux + 1;
					jsux = jsux + 1;
				else    
					x2(irun,:) = ix2(b,:);
					logpo2(irun) = ilogpo2(b);
				end
				j = j + 1;
				irun = irun + 1;
			end
		end
	end
	
	if( j > 100 && (isux/j) > 0.281 )
		prefetch_method = 2;
	else
		prefetch_method = 1;
	end
	
	
	% Hop back in sync with the non-parallel dynare RWMH counting method
	j = j-1;
	irun = irun-1;

	
	
    prtfrc = j/nruns(b);
    if exist('OCTAVE_VERSION')
      if mod(j, 10) == 0
        printf('MH: Computing Metropolis-Hastings (chain %d/%d): %3.f%% done, acception rate: %3.f%%\r', b, nblck, 100 * prtfrc, 100 * isux / j);
      end
	else
		if(~slowness || mod(j,500)==0)
				if(j >= amh_t0)
					set(hh, 'Name', sprintf('A-MH (%.1f%%)', 100*prtfrc));
				else
					set(hh, 'Name', sprintf('MH (%.1f%%)', 100*prtfrc));
				end
		  waitbar(prtfrc,hh,[ '(' int2str(b) '/' int2str(nblck) ') ' sprintf('%f done, acceptation rate %f',prtfrc,isux/j)]);
			end
			if(~slowness && j > 500)
				slowness = true;
				set(hh, 'Name', sprintf('Progress bar slowing now...'));
				drawnow;
			end
	end


		
    if (irun == InitSizeArray(b)) || (j == nruns(b)) % Now I save the simulations

        save([MhDirectoryName '/' ModelName '_mh' int2str(NewFile(b)) '_blck' int2str(b) '.mat'],'x2','logpo2');
        fidlog = fopen([MhDirectoryName '/metropolis.log'],'a');
        fprintf(fidlog,['\n']);
        fprintf(fidlog,['%% Mh' int2str(NewFile(b)) 'Blck' int2str(b) ' (' datestr(now,0) ')\n']);
        fprintf(fidlog,' \n');
        fprintf(fidlog,['  Number of simulations.: ' int2str(length(logpo2)) '\n']);
        fprintf(fidlog,['  Acceptation rate......: ' num2str(jsux/length(logpo2)) '\n']);
        fprintf(fidlog,['  Posterior mean........:\n']);
        for i=1:length(x2(1,:))
            fprintf(fidlog,['    params:' int2str(i) ': ' num2str(mean(x2(:,i))) '\n']);
        end
        fprintf(fidlog,['    log2po:' num2str(mean(logpo2)) '\n']);
        fprintf(fidlog,['  Minimum value.........:\n']);;
        for i=1:length(x2(1,:))
            fprintf(fidlog,['    params:' int2str(i) ': ' num2str(min(x2(:,i))) '\n']);
        end
        fprintf(fidlog,['    log2po:' num2str(min(logpo2)) '\n']);
        fprintf(fidlog,['  Maximum value.........:\n']);
        for i=1:length(x2(1,:))
            fprintf(fidlog,['    params:' int2str(i) ': ' num2str(max(x2(:,i))) '\n']);
        end
        fprintf(fidlog,['    log2po:' num2str(max(logpo2)) '\n']);
        fprintf(fidlog,' \n');
        fclose(fidlog);
        jsux = 0;
        if j == nruns(b) % I record the last draw...
            record.LastParameters(b,:) = x2(end,:);
            record.LastLogLiK(b) = logpo2(end);
        end
        % size of next file in chain b
        InitSizeArray(b) = min(nruns(b)-j,MAX_nruns);
        % initialization of next file if necessary
        if InitSizeArray(b)
            x2 = zeros(InitSizeArray(b),npar);
            logpo2 = zeros(InitSizeArray(b),1);
            NewFile(b) = NewFile(b) + 1;
            irun = 0;
		end
	end
	j=j+1;
    irun = irun + 1;
	
end% End of the simulations for one mh-block.
% record.AcceptationRates(b) = isux/j;
if exist('OCTAVE_VERSION')
  printf('\n');
  diary on;
else
  close(hh);
end

